package de.ivu.elect.presentation.ergebnis.table;

import java.util.function.Function;

import de.ivu.elect.business.ergebnis.entity.GewinnerUnterlegenerStimmendifferenzSearchResult;
import de.ivu.elect.business.kandidatur.control.StimmzettelFormatter;
import de.ivu.elect.business.kandidatur.entity.Direktkandidatur;
import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.presentation.dynamictable.ColumnType;

/**
 *  on 02.06.2015.
 */
public class GewinnerUnterlegenerStimmendifferenzBewerberColumn extends AbstractGewinnerUnterlegenerStimmendifferenzColumn {

  private final Function<GewinnerUnterlegenerStimmendifferenzSearchResult, Direktkandidatur> direktkandidaturFct;

  private final String headerKey;

  private final StimmzettelFormatter stimmzettelFormatter;

  public GewinnerUnterlegenerStimmendifferenzBewerberColumn(Function<GewinnerUnterlegenerStimmendifferenzSearchResult, Direktkandidatur> direktkandidaturFct, String headerKey, Messages messages, StimmzettelFormatter stimmzettelFormatter) {
    super(messages);
    this.direktkandidaturFct = direktkandidaturFct;
    this.headerKey = headerKey;
    this.stimmzettelFormatter = stimmzettelFormatter;
  }

  @Override
  public Object getValue(GewinnerUnterlegenerStimmendifferenzSearchResult gewinnerUnterlegenerStimmendifferenzSearchResult) {
    return stimmzettelFormatter.getKandidaturNamePraesentation(getDirektkandidatur(gewinnerUnterlegenerStimmendifferenzSearchResult));
  }

  protected Direktkandidatur getDirektkandidatur(GewinnerUnterlegenerStimmendifferenzSearchResult gewinnerUnterlegenerStimmendifferenzSearchResult) {
    return direktkandidaturFct.apply(gewinnerUnterlegenerStimmendifferenzSearchResult);
  }

  @Override
  public String getHeader() {
    return getMessage(headerKey);
  }

  @Override
  public ColumnType getType() {
    return ColumnType.STRING;
  }
}
